import os, re, datetime, csv
from TQ import *
from operator import itemgetter

def indCountry(name):
  global cnt
  if not(name in cnt.keys()): cnt[name] = len(cnt)+1
  return cnt[name]

os.chdir('E:/data/airports')

print('start Extract:',datetime.datetime.now().ctime())
eu = [2, 13, 19, 20, 26, 32, 54, 57, 58, 68, 71, 73, 74, 80, 82, 83, 89,
     96, 97, 102, 103, 105, 108, 118, 123, 124, 126, 132, 141, 142, 144,
     152, 160, 163, 173, 174, 178, 179, 190, 194, 195, 201, 207, 208,
     223, 225, 56]

print('Network Flights')
AIR = TQ.Ianus2Mat("./Flights.ten")
print('input done:',datetime.datetime.now().ctime())
mat = AIR['mat']
print('sum =',TQ.MatSummary(mat))
print(AIR.keys())
print('dim =',AIR['dim'])
print('met =',AIR['met'])
print('nam =',AIR['nam'][0:10])
print('tit =',AIR['tit'])
print('typ =',AIR['typ'])
print('tin =',AIR['tin'][0:10])
print('til =',AIR['til'][0:10])
(nr,nc,tmin,tmax) = AIR['dim']
n = len(mat); All = range(n)
names = AIR['nam']
# times = AIR['til']
# act   = AIR['act']

A = [[]]*n; S = [0]*n
for u in range(n):
   a = []
   for v in range(n): 
      a = TQ.sum(a,mat[v][u]) 
   A[u] = a; S[u] = TQ.total(a)
   
P = sorted(enumerate(S),key=itemgetter(1),reverse=True)
# for i in range(100): print(i+1,names[P[i][0]],P[i][1])

print('Countries')

line = 0; n = 2776
nam  = [ "" ]*n; cny  = [ "" ]*n; icny = [ 0 ]*n
iata = [ "" ]*n; icao = [ "" ]*n; tiz  = [ 0 ]*n
lat  = [ 0 ]*n ; lon  = [ 0  ]*n; alt  = [ 0 ]*n 
with open('airportsAtr.csv', newline='', encoding='utf-8') as dat:
  airReader = csv.reader(dat, delimiter=';', quotechar='"')
  try:
    head = next(airReader)
    print('|'.join(head))
    for row in airReader:
      nam[line] = row[1]; cny[line] = row[5]
      iata[line] = row[2]; icao[line] = row[3]; tiz[line] = 0
      lat[line] = row[6]; lon[line] = row[7]; alt[line] = row[8]
      icny[line] = int(row[4])
      line = line+1
  except csv.Error as e:
    sys.exit('file {}, line {}: {}'.format(podatki, airReader.line_num, e))
print("lines = ",line)

L = []; N = []; kmax = n; k = 0
for (i,v) in P:
  if icny[i] in eu:
    print(k,i,iata[i],v,nam[i],cny[i])
    L.append(i); N.append(iata[i]); k = k+1
    if k >= kmax: break
m = len(L)    

B = [[ [] for u in range(m)] for v in range(m)]
for (i,u) in enumerate(L):
   for (j,v) in enumerate(L):
      B[i][j] = mat[u][v]

best = {}
best['mat'] = B
best['dim'] = (m,m,1,295)
best['met'] = AIR['met']            
best['nam'] = N
best['tit'] = "European airports"
best['typ'] = AIR['typ']
best['til'] = AIR['til'][:m]
best['tin'] = AIR['tin']

TQ.MatSave(best,file="bestEU.ten")
print('finished:',datetime.datetime.now().ctime())
