# flightsNet.py
# transforming the monthly flights data 1990-2014 from
#   http://www.transtats.bts.gov/DL_SelectFields.asp?Table_ID=260
# into Pajek's multirelational temporal file
# by Vladimir Batagelj, January 22, 2015

import csv, sys, os, datetime
global air, airports, cmp, companies

def indAirport(name):
  global air, airports
  if not(name in air.keys()):
    air[name] = len(air)+1
    airports.write(str(len(air))+' "'+name+'"\n')
  return air[name]

def indCompany(name):
  global cmp, companies
  if not(name in cmp.keys()):
    cmp[name] = len(cmp)+1
    companies.write(str(len(cmp))+' "'+name+'"\n')
  return cmp[name]

print("MakeAirTen *********")
print('start:',datetime.datetime.now().ctime())
workdir = 'E:/data/airports/'
os.chdir(workdir)

arcs   = open('arcs.tmp', 'w')
arcs.write('*arcs \n')
airports = open('airports.tmp', 'w')
airports.write('*vertices \n')
companies = open('companies.tmp', 'w')
companies.write('*vertices \n')
cmp  = {}; air = {}
line = 0
for year in range(1990,2015):
  podatki = './BTS/BTS'+str(year)+'.csv'  
  with open(podatki, newline='', encoding='utf-8') as dat:
    airReader = csv.reader(dat, delimiter=',', quotechar='"')
    try:
      head = next(airReader)
      for row in airReader:
        arcs.write(str(indCompany(row[4]))+': '+str(indAirport(row[16]))+ \
          ' '+str(indAirport(row[24]))+' '+str(row[0])+' ['+ \
          str(12*(int(row[29])-1990)+int(row[31]))+']\n')  
        line = line+1
    except csv.Error as e:
      sys.exit('file {}, line {}: {}'.format(podatki, airReader.line_num, e))
  print(year,':',datetime.datetime.now().ctime())

print("lines = ",line,"\nairports = ",len(air),"\ncompanies = ",len(cmp))
arcs.close(); airports.close(); companies.close()
print('stop:',datetime.datetime.now().ctime())
